Wednesday, 8 January 2014

Cust 12: Solid Edge Documents: CSharp Part 1

In this tutorial you learn using CSharp, how to:

  1. Create new Solid Edge document.
  2. Save document.
  3. Save As a document with different name.
  4. Open a Solid Edge document.
  5. Count open documents in Solid Edge.
  6. Access the active document.
  7. Export a document to other CAD formats.
  8. Iterate through all open documents.
  9. Activate a desired document from among open documents.
  10. Close a specific document.
  11. Close all open documents at once
image

    Note:

Start Visual Studio and add a Windows Forms Application project.

image

Visual Studio 2010 with .Net framework 4 should work well with Solid Edge 20.

Specify a suitable name for the project and a location and click  OK.

In the Solution Explorer, right click References and select Add Reference...

In the dialog that appears take the COM tab.

Select Solid Edge Framework Type Library from the list.
         image

Solid Edge gets added under References.
image
Add buttons and a listbox to the form as shown.

image

View the code for the form and at the end of the existing
using statements, add the following:

using System;
using System.Collections.Generic;
.

.

using SolidEdgeFramework;
using System.Runtime.InteropServices;

Inside the Form1 class, add a variable oApp for Solid Edge, oDoc for the documents collection and oDoc for a Solid Edge Document.

public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        SolidEdgeFramework.Application oApp;

        SolidEdgeFramework.SolidEdgeDocument oDoc;
        SolidEdgeFramework.Documents oDocs;

 

In the form’s load event add the following code:

oApp = (SolidEdgeFramework.Application)Marshal.GetActiveObject("SolidEdge.Application");

oDocs = oApp.Documents;
oApp.DisplayAlerts = false;

The GetActiveObject method of the Marshal class helps to connect to a running instance of Solid Edge, which in turn is made available by virtue of the

using System.Collections.Generic; statement added earlier.

Here, SolidEdge.Application is the Program ID for Solid Edge which does not change from version to version.

To check this, start the Registry Editor by pressing Windows+R button to invoke the Run utility. Type regedit and press ENTER.

In the registry editor application which looks like the Windows Explorer, select Edit > Find or press F3 and type SolidEdge.Application. After a while it searches for SolidEdge.Application and displays the search as below:

image

If you click the LocalServer32 just above ProgID folder in the left panel, it displays the installed path for Solid Edge.

image

The oDocs variable stores the documents collection of Solid Edge. At the time of the form loading, if no documents are open, the documents collection still exits and has count of 0.

Similarly the oDoc variable is capable of storing any Solid Edge document type viz. Part, Draft, Assembly, etc.

The line oApp.DisplayAlerts = false; suppresses the display of any alert messages or prompts from Solid Edge that may appear during the execution of the program.

Build the project and check if everything is fine.

Back to Visual Studio, double click the Create New Document button and add the following line of code for the button:

oDoc = oApp.Documents.Add("SolidEdge.PartDocument");

This adds a new Part document to the documents collection and is immediately displayed to the screen giving the impression of creating a new document.

Similarly other type of documents can be created by changing the ProGID as below:

oDoc = oApp.Documents.Add("SolidEdge.SheetMetalDocument");

oDoc = oApp.Documents.Add("SolidEdge.AssemblyDocument");

oDoc = oApp.Documents.Add("SolidEdge.DraftDocument");

Or simply use

oDoc = oDocs.Add("SolidEdge.PartDocument");

Since oDocs is same as oApp.Documents as assigned in the form’s load event.

For the Save Document button, simply add:

oDoc.Save();

This invokes the Solid Edge Save File dialog where you can specify a location and file name.

To directly specify a location and file name for saving the document, double click the Save Document As button and enter:

oDoc.SaveAs(Application.StartupPath + "\\Part1.par");

The SaveAs function takes a string which can be build from two parts:

Application.StartupPath which is the location of the Debug or Release folder or the path where ever the exe for this project is kept. To this is appended the filename with an extension. You can also directly specify a hard-coded path as “D:\\Temp\\Part1.par” though its not a recommended practice.

You will see in a subsequent blog post how to invoke a standard Windows file dialog or Solid Edge file dialog that allows user to specify a location and filename for saving a file.

For the Open Document button:

oDoc = oDocs.Open(Application.StartupPath + "\\Part1.par");

This opens a document and adds it to the documents collections and also makes it visible in Solid Edge.

Continued in Part 2…

 image Post a comment below if you need the Visual studio code files and be aware of cMayoCAD where you create your own, brand new, fully functional CAD system with scripting capabilities using a geometric modeling kernel.

Download the detailed course contents for cMayoCAD here.

cMayoCAD24[2]

 cmayocad14